<?php
/*
+ ----------------------------------------------------------------------------+
|     e107 website system
|     /tree_menu.php
|
|     ©Steve Dunstan 2001-2002
|     http://e107.org
|     jalist@e107.org
|
|     Released under the terms and conditions of the
|     GNU General Public License (http://gnu.org).
|
+----------------------------------------------------------------------------+
|     Snake_B
|     http://sbgames.narod.ru
|     e-mail: sbgames@mail.ru
|
|      Revision: 1.4.2 
|      Date: 15/12/2010
|      Author: SBGames`2010
+----------------------------------------------------------------------------+
*/

if (!defined('e107_INIT')) { exit; }
global $tp;
include_lan(e_LANGUAGEDIR.e_LANGUAGE."/lan_sitelinks.php");
unset($text); // Many thanks to Lolo Irie for fixing the javascript that drives this menu item
$query = "SELECT * FROM #links WHERE link_class IN (".USERCLASS_LIST.") ORDER BY link_order ASC";
$sql -> db_Select_gen($query); $linkArray = $sql->db_getList();
$mainLinkArray = array(); // all main links now held in array, we now need to loop through them and assign the sublinks to the correct parent links ...

foreach($linkArray as $links) { // Updated to stop using the deprecated method of splitting the link-name in 3.
	extract ($links); // Now uses uses the link parent to determine the 'tree'.
		if ($link_parent == 0) { // main link - add to main array ...
			$mainLinkArray[$link_id]['id'] = $link_id;
			$mainLinkArray[$link_id]['name'] = $tp->toHtml(strip_tags($link_name),"","defs");
			$mainLinkArray[$link_id]['url'] = $link_url;
			$mainLinkArray[$link_id]['description'] = $link_description;
			$mainLinkArray[$link_id]['image'] = $link_button;
			$mainLinkArray[$link_id]['openMethod'] = $link_open;
			$mainLinkArray[$link_id]['class'] = $link_class;
		} else { // submenu - add to parent's array entry ...
			$tmp = explode(".", $link_name);
			$submenu_name = ($tmp[2]) ? $tmp[2] : $link_name;
			$mainLinkArray[$link_parent]['sublink'][$link_id]['parent_name'] = $link_parent;
			$mainLinkArray[$link_parent]['sublink'][$link_id]['id'] = $link_id;
			$mainLinkArray[$link_parent]['sublink'][$link_id]['name'] = $tp->toHtml(strip_tags($submenu_name));
			$mainLinkArray[$link_parent]['sublink'][$link_id]['url'] = $link_url;
			$mainLinkArray[$link_parent]['sublink'][$link_id]['description'] = $links['link_description'];
			$mainLinkArray[$link_parent]['sublink'][$link_id]['image'] = $link_button;
			$mainLinkArray[$link_parent]['sublink'][$link_id]['openMethod'] = $link_open;
			$mainLinkArray[$link_parent]['sublink'][$link_id]['class'] = $link_class;	}}

$StrCollapsedItemMenu =""; // list of parent links (with sub link) /SB/
$text = ""; // ok, now all mainlinks and sublinks are held in the array, now we have to loop through and build the text to send to screen ...

if ($menu_pref['tm_newview']){ $text = "<link rel='stylesheet' href='".THEME."alt_tree_menu.css' type='text/css'/>"; } // Include CSS in user theme /SB/
	foreach($mainLinkArray as $links) { extract ($links);
	$Opened_PAGE=e_SELF; if(e_QUERY != ""){ $Opened_PAGE .="?"; $Opened_PAGE .=e_QUERY;} // V.1.3.0 Active page selection /SB/
	if (array_key_exists("sublink", $links) && $links['name'] != "") { // sublinks found
		$url = "javascript:void(0);"; $spanName = $id;
		if ($menu_pref['tm_newview']){ 
		                $image = (""); $plink ="
			<div class='MenuPCH1' onclick='CollapsedMenu(\"".$spanName."\");'>".$image." ".alt_setLink($name, $url, $openMethod, $description, "0", $Opened_PAGE)."</div>";
		} else {
			$image = ($image ? "<img src='".e_IMAGE_ABS."icons/".$image."' alt='' style='vertical-align:middle;' />" : "&raquo;");
			$plink = "<div".($menu_pref['tm_class2'] ? " class='{$menu_pref['tm_class2']}'" : "")." style='width:100%; cursor: pointer;' 								onclick='expandit(\"span_".$spanName."\");updatecook(\"".$spanName."\");'>".$image." ".setLink($name, $url, $openMethod, $description)."</div>\n"; }
		$text .= ($menu_pref['tm_spacer'] ? "<div class='spacer'>\n".$plink."\n</div>\n" : $plink); // Отступ между пунктами, вкл. из админки....
	if ($menu_pref['tm_newview']){ if ($menu_pref['tm_autocollapse']){ 
	                $StrCollapsedItemMenu .= "if (document.getElementById('span_";
	                $StrCollapsedItemMenu .= $spanName;
	                $StrCollapsedItemMenu .="').style.display!='none') {expandit('span_";
	                $StrCollapsedItemMenu .=$spanName;
	                $StrCollapsedItemMenu .="'); updatecook(itemmenu);}";}}
	} else {
		if($links['name']){ // no sublinks found ...
			$linkName = $url; $spanName = "";
			if ($menu_pref['tm_newview']){ 
			                $image = (""); $temp=$pref['siteurl'].$url; // V.1.3.0 
				if($temp  === $Opened_PAGE){ // V.1.3.0 
					$plink = "
					<div class='MenuPCH4'> 
					".$image." ".alt_setLink($name, $temp, $openMethod, $description, "1", $Opened_PAGE)."</div>";
				} else {
					$plink = "
					<div class='MenuPCH2'> 
					".$image." ".alt_setLink($name, $url, $openMethod, $description, "1", $Opened_PAGE)."</div>";}
			} else {
				$image = ($image ? "<img src='".e_IMAGE_ABS."icons/".$image."' alt='' style='vertical-align:middle;' />" : "&middot;");
				$plink = "<div".($menu_pref['tm_class1'] ? " class='{$menu_pref['tm_class1']}'" : "")." 
				style='width:100%; cursor: pointer;'>".$image." ".setLink($name, $url, $openMethod, $description)."</div>";}
			$text .= ($menu_pref['tm_spacer'] ? "<div class='spacer'>\n".$plink."\n</div>\n" : $plink); }}
	$c = 0; if (array_key_exists("sublink", $links) && $links['name'] != "" ) {
		$text .= "<span style=\"display:none\" id=\"span_".$spanName."\">";
		foreach($sublink as $link) { extract($link);
		if ($menu_pref['tm_newview']){  $image = (""); 
		} else {
			$image = ($image ? "<img src='".e_IMAGE_ABS."icons/".$image."' alt='' style='vertical-align:middle' />  " : "&middot; ");}
             		$spanName = $parent_name;
		if ($menu_pref['tm_newview']){ 
                                                $temp=$pref['siteurl'].$url; // V.1.3.0 	
			$plink ="<div class='MenuPCH3'> ".$image." ".alt_setLink($name, $temp, $openMethod, $description, "2", $Opened_PAGE)."</div>";
		} else {
			$plink = $image." ".setLink($name, $url, $openMethod, $description)."<br />\n";}
		$text .=($menu_pref['tm_class3'] ? "<span".($menu_pref['tm_class3'] ? " class='{$menu_pref['tm_class3']}'" : "").">".$plink."</span>\n\n" : $plink);}
	$text .="</span>\n";}}


function alt_setlink($link_name, $link_url, $link_open, $link_description, $flag, $Opened_PAGE) { // For new style /SB/
global $tp;
	switch ($link_open) {
		case 1: $link_append = "rel='external'"; break;
		case 2: $link_append = ""; break;
		case 3: $link_append = ""; break;
		default: $link_append = '';}
	if (!strstr($link_url, "http:") && !strstr($link_url, "void") && strpos($link_url, "mailto:") !== 0) {$link_url = e_BASE.$link_url;}
	$link_url =$tp->replaceConstants($link_url, $nonrelative = TRUE, $all = false);
	if ($link_open == 4) {
		$link = "<a style='text-decoration:none' title='".$link_description."' href=\"javascript:open_window('".$link_url."')\">".$link_name."</a>\n";
	} else {
		if ($flag == "0"){ // With submenu /SB/ // V.1.4.2
			$link = "<a title='".$link_description."' href='#' onclick='javascript:void(0); return false' onfocus='this.blur()/'>".$link_name."</a>\n"; }
		if ($flag == "1"){ // With not submenu /SB/
			if($link_url === $Opened_PAGE){ // V.1.3.0 
				$link_url = "javascript:void(0);"; // Page not opened
				$link = "<a class=onpage title='".$link_description."' href=\"".$link_url."\" ".$link_append.">".$link_name."</a>\n";
			} else {
				$link = "<a title='".$link_description."' href=\"".$link_url."\" ".$link_append.">".$link_name."</a>\n"; }}
		if ($flag == "2"){ // Sub links /SB/
			if($link_url === $Opened_PAGE){ // V.1.3.0 
				$link_url = "javascript:void(0);"; // Page not opened	
				$link = "<a class=onpage title='".$link_description."' href=\"".$link_url."\" ".$link_append.">".$link_name."</a>\n";
			} else {
			$link = "<a title='".$link_description."' href=\"".$link_url."\" ".$link_append.">".$link_name."</a>\n"; }}} 
return $link; }


function setlink($link_name, $link_url, $link_open, $link_description) { // For old style /SB/
global $tp;
	switch ($link_open) {
		case 1: $link_append = "rel='external'"; break;
		case 2: $link_append = ""; break;
		case 3: $link_append = ""; break;
		default: $link_append = ''; }
	if (!strstr($link_url, "http:") && !strstr($link_url, "void") && strpos($link_url, "mailto:") !== 0) {$link_url = e_BASE.$link_url;	}
	$link_url =$tp->replaceConstants($link_url, $nonrelative = TRUE, $all = false);
	if ($link_open == 4) {
		$link = "<a style='text-decoration:none' title='".$link_description."' href=\"javascript:open_window('".$link_url."')\">".$link_name."</a>\n";
	} else {
		$link = "<a style='text-decoration:none' title='".$link_description."' href=\"".$link_url."\" ".$link_append.">".$link_name."</a>\n";}
return $link; }

(isset($_COOKIE["treemenustatus"]) && $_COOKIE["treemenustatus"]) ? $treemenustatus = $_COOKIE["treemenustatus"] : $treemenustatus = "0";

$text .= "
	<script type='text/javascript'>
	<!--";
if ($menu_pref['tm_newview']){ 
$text .= "
function CollapsedMenu(itemmenu){
	cookitem='span_'+itemmenu;
	if (document.getElementById(cookitem).style.display!='none'){ 
		expandit('span_'+itemmenu); updatecook(itemmenu);
	}else{
";
$text .= $StrCollapsedItemMenu; }
$text .= "
                expandit('span_'+itemmenu); updatecook(itemmenu); } }\n
function updatecook(itemmenu){
	cookitem='span_'+itemmenu;
	if (document.getElementById(cookitem).style.display!='none'){
		var expireDate = new Date;
		expireDate.setMinutes(expireDate.getMinutes()+10);
		document.cookie = \"treemenustatus=\" + itemmenu + \"; expires=\" + expireDate.toGMTString()+\";path=/\";
	}else{
		clearcook();}}\n

function clearcook(){
	var expireDate = new Date;
	expireDate.setMinutes(expireDate.getMinutes()+10);
	document.cookie = \"treemenustatus=\" + \"0\" + \"; expires=\" + expireDate.toGMTString();}\n//-->\n";

(($treemenustatus != "0" && isset($treemenustatus))?$text .= "window.onload=document.getElementById('span_".$treemenustatus."').style.display=''":"");
$text .= "</script>";


if ($menu_pref['tm_menuview']){ 
	echo $text; // For view with out menu table 1.3.0 /SB/
} else {
	$ns->tablerender(LAN_SITELINKS_183, $text, 'tree_menu');
}
?>